/*
Dataddo Headless BETA API

Dataddo Headless BETA API

API version: 1.0.0-beta.1
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package customer_api

import (
	"encoding/json"
)

// checks if the GoogleAdsControllerActionMetricRequest type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &GoogleAdsControllerActionMetricRequest{}

// GoogleAdsControllerActionMetricRequest struct for GoogleAdsControllerActionMetricRequest
type GoogleAdsControllerActionMetricRequest struct {
	ReportType *string `json:"reportType,omitempty"`
}

// NewGoogleAdsControllerActionMetricRequest instantiates a new GoogleAdsControllerActionMetricRequest object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewGoogleAdsControllerActionMetricRequest() *GoogleAdsControllerActionMetricRequest {
	this := GoogleAdsControllerActionMetricRequest{}
	return &this
}

// NewGoogleAdsControllerActionMetricRequestWithDefaults instantiates a new GoogleAdsControllerActionMetricRequest object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewGoogleAdsControllerActionMetricRequestWithDefaults() *GoogleAdsControllerActionMetricRequest {
	this := GoogleAdsControllerActionMetricRequest{}
	return &this
}

// GetReportType returns the ReportType field value if set, zero value otherwise.
func (o *GoogleAdsControllerActionMetricRequest) GetReportType() string {
	if o == nil || IsNil(o.ReportType) {
		var ret string
		return ret
	}
	return *o.ReportType
}

// GetReportTypeOk returns a tuple with the ReportType field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GoogleAdsControllerActionMetricRequest) GetReportTypeOk() (*string, bool) {
	if o == nil || IsNil(o.ReportType) {
		return nil, false
	}
	return o.ReportType, true
}

// HasReportType returns a boolean if a field has been set.
func (o *GoogleAdsControllerActionMetricRequest) HasReportType() bool {
	if o != nil && !IsNil(o.ReportType) {
		return true
	}

	return false
}

// SetReportType gets a reference to the given string and assigns it to the ReportType field.
func (o *GoogleAdsControllerActionMetricRequest) SetReportType(v string) {
	o.ReportType = &v
}

func (o GoogleAdsControllerActionMetricRequest) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o GoogleAdsControllerActionMetricRequest) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.ReportType) {
		toSerialize["reportType"] = o.ReportType
	}
	return toSerialize, nil
}

type NullableGoogleAdsControllerActionMetricRequest struct {
	value *GoogleAdsControllerActionMetricRequest
	isSet bool
}

func (v NullableGoogleAdsControllerActionMetricRequest) Get() *GoogleAdsControllerActionMetricRequest {
	return v.value
}

func (v *NullableGoogleAdsControllerActionMetricRequest) Set(val *GoogleAdsControllerActionMetricRequest) {
	v.value = val
	v.isSet = true
}

func (v NullableGoogleAdsControllerActionMetricRequest) IsSet() bool {
	return v.isSet
}

func (v *NullableGoogleAdsControllerActionMetricRequest) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableGoogleAdsControllerActionMetricRequest(val *GoogleAdsControllerActionMetricRequest) *NullableGoogleAdsControllerActionMetricRequest {
	return &NullableGoogleAdsControllerActionMetricRequest{value: val, isSet: true}
}

func (v NullableGoogleAdsControllerActionMetricRequest) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableGoogleAdsControllerActionMetricRequest) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
